diff -ruN freeswan-1.9.orig/pluto/xmap_db.c freeswan-1.9/pluto/xmap_db.c
--- freeswan-1.9.orig/pluto/xmap_db.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_db.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,574 @@
+#ifdef OPENSSL
+#if defined(HAVE_DB) || (HAVE_DB185)
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <errno.h>
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#ifdef HAVE_DB185
+#include <db_185.h>
+#else
+#include <db.h>
+#endif
+
+#include <openssl/bio.h>
+#include <openssl/pem.h>
+#include <openssl/x509v3.h>
+
+#include "xmap_db.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static void XMAP_DB_dump(void *this);
+static void XMAP_DB_free(void *this);
+static void *XMAP_DB_new(const char *dbname);
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup( void *this, const int type, const char *index, void *p );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_subject( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_issuer( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_crl_by_issuer( XMAP_DB *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_uid( XMAP_DB *xm, const char *uid );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_dns( XMAP_DB *xm, const char *dns );
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_ip( XMAP_DB *xm, const struct in_addr ip);
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_ca_certs( XMAP_DB *xm );
+
+#define TAGLEN 4
+
+static unsigned char tag_cert[] = { 0x00, 0x00, 0x00, 0x00 };
+static unsigned char tag_subj[] = { 0x00, 0x00, 0x00, 0x01 };
+static unsigned char tag_csub[] = { 0x00, 0x00, 0x00, 0x02 };
+static unsigned char tag_uid[] = { 0x00, 0x00, 0x00, 0x03 };
+static unsigned char tag_crl[] = { 0x00, 0x00, 0x00, 0x04 };
+static unsigned char tag_ca[] = { 0x00, 0x00, 0x00, 0x05 };
+static unsigned char tag_dns[] = { 0x00, 0x00, 0x00, 0x06 };
+static unsigned char tag_ip[] = { 0x00, 0x00, 0x00, 0x07 };
+
+#define DBZ(x) memset(&(x), 0, sizeof((x)))
+
+static XMAP_METHOD xmap_db_methods = {
+  "db",
+  XMAP_DB_lookup,
+  XMAP_DB_dump,
+  XMAP_DB_free,
+  XMAP_DB_new
+};
+
+void *
+XMAP_DB_new(const char *dbname)
+{
+  XMAP_DB *ret;
+
+  if ((ret = alloc_thing(XMAP_DB, "xmap_db")) == NULL) goto end;
+  if ((ret->dbname = clone_bytes(dbname, strlen(dbname)+1, "dbname")) == NULL)
+    goto end;
+  if ((ret->db = dbopen(dbname, O_RDONLY, 0, DB_HASH, NULL)) == NULL)
+    goto end;
+
+  ret->meth = &xmap_db_methods;
+
+  return (void *)ret;
+ end:
+  if (ret->db) ret->db->close(ret->db);
+  if (ret->dbname) pfree(ret->dbname);
+  if (ret) pfree(ret);
+  return NULL;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup( void *this, const int type, const char *index, void *p )
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+
+  switch(type) {
+  case X509_LU_X509:
+    if (strcasecmp(index, "subject") == 0)
+      return XMAP_DB_lookup_cert_by_subject( xm, (X509_NAME *)p);
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DB_lookup_cert_by_issuer( xm, (X509_NAME *)p);
+    else if (strcasecmp(index, "uid") == 0)
+      return XMAP_DB_lookup_cert_by_uid( xm, (char  *)p);
+    else if (strcasecmp(index, "dns") == 0)
+      return XMAP_DB_lookup_cert_by_dns( xm, (char  *)p);
+    else if (strcasecmp(index, "ip") == 0)
+      return XMAP_DB_lookup_cert_by_ip( xm, *((struct in_addr *)p));
+    else if (strcasecmp(index, "ca") == 0)
+      return XMAP_DB_lookup_ca_certs( xm );
+    else
+      return NULL;
+    break;
+  case X509_LU_CRL:
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DB_lookup_crl_by_issuer( xm, (X509_NAME *)p);
+    else
+      return NULL;
+    break;
+  default:
+    return NULL;
+  }
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_subject(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_subj, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	  if (x)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_issuer(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_subj, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	  if (x)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_crl_by_issuer(XMAP_DB *xm, X509_NAME *name)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  dlen = i2d_X509_NAME(name, NULL);
+  if ((d = alloc_bytes(dlen + TAGLEN, "ASN.1 name")) == NULL) goto end;
+  dum = &d[TAGLEN];
+  memcpy(d, tag_csub, TAGLEN);
+  i2d_X509_NAME(name, &dum);
+  k.data = d;
+  k.size = dlen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_crl, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[i*SHA_DIGEST_LENGTH+TAGLEN], SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509_CRL *c;
+	dum = (unsigned char *)v2.data;
+	if ((c = d2i_X509_CRL(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_CRL, c);
+
+	  if (xo)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_CRL_free(c);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_ca_certs( XMAP_DB *xm )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  if ((d = alloc_bytes(TAGLEN, "CA tag")) == NULL) goto end;
+  memcpy(d, tag_ca, TAGLEN);
+  k.data = d;
+  k.size = TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if (((x = d2i_X509(NULL, &dum, v2.size)) != NULL) && (isCA(x))) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+
+	  if (xo) 
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_uid(XMAP_DB *xm, const char *uid)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = strlen(uid);
+  if ((d = alloc_bytes(ulen + TAGLEN, "uid tag")) == NULL) goto end;
+  memcpy(d, tag_uid, TAGLEN);
+  strncpy(&d[TAGLEN], uid, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+
+	  if (xo) 
+	    sk_X509_OBJECT_push(sk, xo);
+	  else
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_dns(XMAP_DB *xm, const char *dns)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = strlen(dns);
+  if ((d = alloc_bytes(ulen + TAGLEN, "dns tag")) == NULL) goto end;
+  memcpy(d, tag_dns, TAGLEN);
+  strncpy(&d[TAGLEN], dns, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  if (X509_subjAltName_check_dns(x, dns)) {
+	    X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	    
+	    if (xo) 
+	      sk_X509_OBJECT_push(sk, xo);
+	    else
+	      X509_free(x);
+	  } else 
+	    X509_free(x);
+	}
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) free(d);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DB_lookup_cert_by_ip(XMAP_DB *xm, const struct in_addr ip)
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  DBT k, v;
+  unsigned char *d, *dum;
+  unsigned int i, ulen, dlen;
+
+  DBZ(k);
+  DBZ(v);
+  if (!xm->db) goto end;
+  ulen = sizeof(ip.s_addr);
+  if ((d = alloc_bytes(ulen + TAGLEN, "ip tag")) == NULL) goto end;
+  memcpy(d, tag_ip, TAGLEN);
+  memcpy(&d[TAGLEN], &ip.s_addr, ulen);
+  k.data = d;
+  k.size = ulen + TAGLEN;
+  if (xm->db->get(xm->db, &k, &v, 0) == 0) {
+    u_int32_t c1, c2;
+
+    memcpy((unsigned char *)&c1, v.data, sizeof(c1));
+    c2 = ntohl(c1);
+    pfree(d); d = NULL;
+    dlen = SHA_DIGEST_LENGTH + TAGLEN;
+    if ((d = alloc_bytes(dlen, "SHA-1 tag")) == NULL) goto end;
+    memcpy(d, tag_cert, TAGLEN);
+    for(i=0; i<c2; i++) {
+      unsigned char *vv = v.data;
+      DBT v2;
+
+      DBZ(v2);
+      memcpy(&(d[TAGLEN]), &vv[(i*SHA_DIGEST_LENGTH)+TAGLEN],
+	     SHA_DIGEST_LENGTH);
+      k.data = d;
+      k.size = dlen;
+      if (xm->db->get(xm->db, &k, &v2, 0) == 0) {
+	X509 *x;
+	dum = (unsigned char *)v2.data;
+
+        DBG(DBG_PARSING | DBG_RAW,
+        DBG_log("** v2 length: %d", v2.size);
+        );
+        DBG(DBG_RAW,
+        DBG_dump("** v2: ", v2.data, v2.size);
+        );
+
+	if ((x = d2i_X509(NULL, &dum, v2.size)) != NULL) {
+	  if (X509_subjAltName_check_ip(x, ip)) {
+	    X509_OBJECT *xo = X509_OBJECT_new( X509_LU_X509, x);
+	    
+	    if (xo) 
+	      sk_X509_OBJECT_push(sk, xo);
+	    else
+	      X509_free(x);
+	  }
+	} else
+	  X509_free(x);
+      }
+    }
+    pfree(d); d = NULL;
+  }
+ end:
+  if (d) pfree(d);
+  return sk;
+}
+
+static void
+XMAP_DB_dump(void *this)
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+  DBG(DBG_PARSING,
+  DBG_log("XMAP_DB: %s", xm->dbname);
+  );
+}
+
+static void
+XMAP_DB_free(void *this)
+{
+  XMAP_DB *xm = (XMAP_DB *)this;
+
+  if (!xm) return;
+  if (xm->dbname) pfree(xm->dbname);
+  if (xm->db) xm->db->close(xm->db);
+  pfree(xm);
+}
+
+XMAP_METHOD *
+XMAP_METHOD_db( void )
+{
+  return (&xmap_db_methods);
+}
+#endif /* HAVE_DB */
+#endif /* OPENSSL */
diff -ruN freeswan-1.9.orig/pluto/xmap_db.h freeswan-1.9/pluto/xmap_db.h
--- freeswan-1.9.orig/pluto/xmap_db.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_db.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,27 @@
+#ifndef XMAP_DB_H
+#define XMAP_DB_H
+
+#if defined(HAVE_DB) || defined(HAVE_DB185)
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+
+#ifdef HAVE_DB185
+#include <db_185.h>
+#else
+#include <db.h>
+#endif
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct xmap_db_st {
+  char *dbname;
+  DB *db;
+  XMAP_METHOD *meth;
+} XMAP_DB;
+
+XMAP_METHOD *XMAP_METHOD_db( void );
+
+#endif /* HAVE_DB */
+#endif /* XMAP_DB_H */
diff -ruN freeswan-1.9.orig/pluto/xmap_dir.c freeswan-1.9/pluto/xmap_dir.c
--- freeswan-1.9.orig/pluto/xmap_dir.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_dir.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,545 @@
+#ifdef OPENSSL
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <dirent.h>
+#include <sys/stat.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <errno.h>
+
+#include <openssl/bio.h>
+#include <openssl/pem.h>
+#include <openssl/err.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+
+#include "xmap_dir.h"
+#include "xmap.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static void XMAP_DIR_dump(void *this);
+static void XMAP_DIR_free(void *this);
+static void *XMAP_DIR_new(const char *dir);
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup( void *this, const int type, const char *index, void *p );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_subject( XMAP_DIR *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_issuer( XMAP_DIR *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_crl_by_issuer( XMAP_DIR *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_uid( XMAP_DIR *xm, const char *uid );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_dns( XMAP_DIR *xm, const char *dns );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_ip( XMAP_DIR *xm, const struct in_addr ip );
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_ca_certs( XMAP_DIR *xm );
+
+static XMAP_METHOD xmap_dir_methods = {
+  "dir",
+  XMAP_DIR_lookup,
+  XMAP_DIR_dump,
+  XMAP_DIR_free,
+  XMAP_DIR_new
+};
+
+static void *
+XMAP_DIR_new(const char *dir)
+{
+  XMAP_DIR *ret;
+
+  if ((ret = alloc_thing(XMAP_DIR, "xmap_dir")) == NULL) goto end;
+  if ((ret->dir = clone_bytes(dir, strlen(dir)+1, "directory name")) == NULL)
+    goto end;
+  ret->meth = &xmap_dir_methods;
+
+  return (void *)ret;
+ end:
+  if (ret->dir) pfree(ret->dir);
+  if (ret) pfree(ret);
+  return NULL;
+}
+
+static int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup( void *this, const int type, const char *index, void *p )
+{
+  XMAP_DIR *xm = (XMAP_DIR *)this;
+
+  switch(type) {
+  case X509_LU_X509:
+    if (strcasecmp(index, "subject") == 0)
+      return XMAP_DIR_lookup_cert_by_subject( xm, (X509_NAME *)p);
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DIR_lookup_cert_by_issuer( xm, (X509_NAME *)p);
+    else if (strcasecmp(index, "uid") == 0)
+      return XMAP_DIR_lookup_cert_by_uid( xm, (char  *)p);
+    else if (strcasecmp(index, "dns") == 0)
+      return XMAP_DIR_lookup_cert_by_dns( xm, (char  *)p);
+    else if (strcasecmp(index, "ip") == 0)
+      return XMAP_DIR_lookup_cert_by_ip( xm, *(struct in_addr *)p);
+    else if (strcasecmp(index, "ca") == 0)
+      return XMAP_DIR_lookup_ca_certs( xm );
+    else
+      return NULL;
+    break;
+  case X509_LU_CRL:
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_DIR_lookup_crl_by_issuer( xm, (X509_NAME *)p);
+    else
+      return NULL;
+    break;
+  default:
+    return NULL;
+  }
+}
+
+static char hashval[PATH_MAX+1] = "";
+static char dirname[PATH_MAX+1] = "";
+
+static int
+hash_select(const struct dirent *de)
+{
+  int l = strlen(hashval);
+
+  if (strncmp(de->d_name, hashval, l) == 0) {
+    return 1;
+  } else {
+    return 0;
+  }
+}
+
+static int
+select_files(const struct dirent *de)
+{
+  struct stat st;
+  char path[PATH_MAX+1];
+  
+  snprintf(path, sizeof(path), "%s/%s", dirname, de->d_name);
+  if (lstat(path, &st) == 0) {
+    if (S_ISREG(st.st_mode))
+      return 1;
+    else
+      return 0;
+  } else {
+    log("error in stat: %s", strerror(errno));
+    return 0;
+  }     
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_subject( XMAP_DIR *xm, X509_NAME *name )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  snprintf(hashval, sizeof(hashval)-1, "%08lx.cert", X509_NAME_hash(name));
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error on scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  if (X509_NAME_cmp(X509_get_subject_name(x), name) == 0) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+
+	    if (x) {
+	      sk_X509_OBJECT_push(sk, xo);
+	    } else
+	      X509_free(x);
+	  } else
+	    X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_issuer( XMAP_DIR *xm, X509_NAME *name )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  snprintf(hashval, sizeof(hashval)-1, "%08lx.cert", X509_NAME_hash(name));
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error on scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  if (X509_NAME_cmp(X509_get_issuer_name(x), name) == 0) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+
+	    if (x) {
+	      sk_X509_OBJECT_push(sk, xo);
+	    } else
+	      X509_free(x);
+	  } else
+	    X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_ca_certs( XMAP_DIR *xm )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  strncpy(dirname, xm->dir, sizeof(dirname)-1);
+  n = scandir(xm->dir, &flist, select_files, alphasort);
+  if (n < 0)
+    log("error in scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  if (isCA(x)) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+
+	    if (xo) {
+	      sk_X509_OBJECT_push(sk, xo);
+	    } else
+	      X509_free(x);
+	  } else
+	    X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_crl_by_issuer( XMAP_DIR *xm, X509_NAME *name )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  snprintf(hashval, sizeof(hashval)-1, "%08lx.crl", X509_NAME_hash(name));
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error in scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509_CRL *c;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((c = PEM_read_bio_X509_CRL(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  c = d2i_X509_CRL_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (c) {
+	  if (X509_NAME_cmp(X509_CRL_get_issuer(c), name) == 0) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_CRL, c);
+	    if (xo)
+	      sk_X509_OBJECT_push(sk, xo);
+	    else
+	      X509_CRL_free(c);
+	  } else
+	    X509_CRL_free(c);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_uid( XMAP_DIR *xm, const char *uid )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  snprintf(hashval, sizeof(hashval)-1, "uid-%s", uid);
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error in scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+	  if (xo)
+	    sk_X509_OBJECT_push(sk, xo);
+	  else 
+	    X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_dns( XMAP_DIR *xm, const char *dns )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  snprintf(hashval, sizeof(hashval)-1, "dns-%s", dns);
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error in scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  if (X509_subjAltName_check_dns(x, dns)) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+	    if (xo)
+	      sk_X509_OBJECT_push(sk, xo);
+	    else 
+	      X509_free(x);
+	  }
+	} else {
+	  X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_DIR_lookup_cert_by_ip( XMAP_DIR *xm, const struct in_addr ip )
+{
+  char path[PATH_MAX+1];
+  int n;
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  struct dirent **flist;
+
+  if (!sk) return sk;
+  
+  snprintf(hashval, sizeof(hashval)-1, "ip-%s", inet_ntoa(ip));
+  n = scandir(xm->dir, &flist, hash_select, alphasort);
+  if (n < 0)
+    log("error in scandir: %s", strerror(errno));
+  else {
+    int i;
+
+    for(i=0; i<n; i++) {
+      BIO *b;
+
+      snprintf(path, sizeof(path)-1, "%s/%s", xm->dir, flist[i]->d_name);
+      
+      if ((b = BIO_new_file(path, "r")) != NULL) {
+	X509 *x;
+
+	/* Try a PEM load first, then try DER if it fails */
+	if ((x = PEM_read_bio_X509(b, NULL, NULL, NULL)) == NULL) {
+	  BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	  x = d2i_X509_bio(b, NULL); /* Try DER loading */
+	}
+
+	if (x) {
+	  if (X509_subjAltName_check_ip(x, ip)) {
+	    X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+	    if (xo)
+	      sk_X509_OBJECT_push(sk, xo);
+	    else 
+	      X509_free(x);
+	  }
+	} else {
+	  X509_free(x);
+	}
+
+	BIO_free(b);
+      } else {
+	ERR_print_errors_fp(stderr);
+      }
+    }
+    if (n > 0) free(flist);
+  }
+  return sk;
+}
+
+static void
+XMAP_DIR_dump(void *this)
+{
+  XMAP_DIR *xm = (XMAP_DIR *)this;
+  DBG_log("XMAP_DIR: %s", xm->dir);
+}
+
+static void
+XMAP_DIR_free(void *this)
+{
+  XMAP_DIR *xm = (XMAP_DIR *)this;
+
+  if (!xm) return;
+  if (xm->dir) pfree(xm->dir);
+  free(xm);
+}
+
+XMAP_METHOD *
+XMAP_METHOD_dir( void )
+{
+  return (&xmap_dir_methods);
+}
+#endif /* OPENSSL */
diff -ruN freeswan-1.9.orig/pluto/xmap_dir.h freeswan-1.9/pluto/xmap_dir.h
--- freeswan-1.9.orig/pluto/xmap_dir.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_dir.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,17 @@
+#ifndef XMAP_DIR_H
+#define XMAP_DIR_H
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct xmap_dir_st {
+  char *dir;
+  XMAP_METHOD *meth;
+} XMAP_DIR;
+
+XMAP_METHOD *XMAP_METHOD_dir( void );
+
+#endif /* XMAP_DIR_H */
